diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/bindings/modulegen__gcc_LP64.py ns-3.36/src/spectrum/bindings/modulegen__gcc_LP64.py
--- ns-3.35/src/spectrum/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/bindings/modulegen__gcc_LP64.py	2022-04-30 18:23:58.142734800 -0700
@@ -6052,32 +6115,32 @@
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['bool'], visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::MobilityModel const> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['ns3::Ptr<ns3::Packet> '], visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::SpectrumPhy const> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['ns3::Ptr<ns3::MobilityModel const> '], visibility='protected')
+                   is_static=True, template_parameters=['double'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['ns3::Ptr<ns3::SpectrumPhy const> '], visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::SpectrumSignalParameters> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['double'], visibility='protected')
+                   is_static=True, template_parameters=['bool'], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
                    [], 
-                   is_static=True, template_parameters=['ns3::Ptr<ns3::SpectrumSignalParameters> '], visibility='protected')
+                   is_static=True, template_parameters=['ns3::Ptr<ns3::Packet> '], visibility='protected')
     ## callback.h (module 'core'): static std::string ns3::CallbackImplBase::GetCppTypeid() [member function]
     cls.add_method('GetCppTypeid', 
                    'std::string', 
@@ -6162,10 +6225,10 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
-    ## channel-condition-model.h (module 'propagation'): bool ns3::ChannelCondition::IsEqual(ns3::Ptr<const ns3::ChannelCondition> otherCondition) const [member function]
+    ## channel-condition-model.h (module 'propagation'): bool ns3::ChannelCondition::IsEqual(ns3::ChannelCondition::LosConditionValue losCondition, ns3::ChannelCondition::O2iConditionValue o2iCondition) const [member function]
     cls.add_method('IsEqual', 
                    'bool', 
-                   [param('ns3::Ptr< ns3::ChannelCondition const >', 'otherCondition')], 
+                   [param('ns3::ChannelCondition::LosConditionValue', 'losCondition'), param('ns3::ChannelCondition::O2iConditionValue', 'o2iCondition')], 
                    is_const=True)
     ## channel-condition-model.h (module 'propagation'): bool ns3::ChannelCondition::IsI2i() const [member function]
     cls.add_method('IsI2i', 
@@ -6890,9 +6953,9 @@
                    'ns3::Ptr< ns3::SpectrumModel const >', 
                    [], 
                    is_const=True, is_virtual=True)
-    ## half-duplex-ideal-phy.h (module 'spectrum'): ns3::Ptr<ns3::AntennaModel> ns3::HalfDuplexIdealPhy::GetRxAntenna() const [member function]
-    cls.add_method('GetRxAntenna', 
-                   'ns3::Ptr< ns3::AntennaModel >', 
+    ## half-duplex-ideal-phy.h (module 'spectrum'): ns3::Ptr<ns3::Object> ns3::HalfDuplexIdealPhy::GetAntenna() const [member function]
+    cls.add_method('GetAntenna', 
+                   'ns3::Ptr< ns3::Object >', 
                    [], 
                    is_const=True, is_virtual=True)
     ## half-duplex-ideal-phy.h (module 'spectrum'): void ns3::HalfDuplexIdealPhy::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
@@ -7356,11 +7419,16 @@
                    'ns3::Ptr< ns3::MatrixBasedChannelModel::ChannelMatrix const >', 
                    [param('ns3::Ptr< ns3::MobilityModel const >', 'aMob'), param('ns3::Ptr< ns3::MobilityModel const >', 'bMob'), param('ns3::Ptr< ns3::PhasedArrayModel const >', 'aAntenna'), param('ns3::Ptr< ns3::PhasedArrayModel const >', 'bAntenna')], 
                    is_pure_virtual=True, is_virtual=True)
-    ## matrix-based-channel-model.h (module 'spectrum'): static uint32_t ns3::MatrixBasedChannelModel::GetKey(uint32_t x1, uint32_t x2) [member function]
+    ## matrix-based-channel-model.h (module 'spectrum'): static uint64_t ns3::MatrixBasedChannelModel::GetKey(uint32_t a, uint32_t b) [member function]
     cls.add_method('GetKey', 
-                   'uint32_t', 
-                   [param('uint32_t', 'x1'), param('uint32_t', 'x2')], 
+                   'uint64_t', 
+                   [param('uint32_t', 'a'), param('uint32_t', 'b')], 
                    is_static=True)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::Ptr<const ns3::MatrixBasedChannelModel::ChannelParams> ns3::MatrixBasedChannelModel::GetParams(ns3::Ptr<const ns3::MobilityModel> aMob, ns3::Ptr<const ns3::MobilityModel> bMob) const [member function]
+    cls.add_method('GetParams', 
+                   'ns3::Ptr< ns3::MatrixBasedChannelModel::ChannelParams const >', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'aMob'), param('ns3::Ptr< ns3::MobilityModel const >', 'bMob')], 
+                   is_const=True, is_pure_virtual=True, is_virtual=True)
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::AOA_INDEX [variable]
     cls.add_static_attribute('AOA_INDEX', 'uint8_t const', is_const=True)
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::AOD_INDEX [variable]
@@ -7376,23 +7444,40 @@
     cls.add_constructor([])
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::ChannelMatrix(ns3::MatrixBasedChannelModel::ChannelMatrix const & arg0) [constructor]
     cls.add_constructor([param('ns3::MatrixBasedChannelModel::ChannelMatrix const &', 'arg0')])
-    ## matrix-based-channel-model.h (module 'spectrum'): bool ns3::MatrixBasedChannelModel::ChannelMatrix::IsReverse(uint32_t const aId, uint32_t const bId) const [member function]
+    ## matrix-based-channel-model.h (module 'spectrum'): bool ns3::MatrixBasedChannelModel::ChannelMatrix::IsReverse(uint32_t aAntennaId, uint32_t bAntennaId) const [member function]
     cls.add_method('IsReverse', 
                    'bool', 
-                   [param('uint32_t const', 'aId'), param('uint32_t const', 'bId')], 
+                   [param('uint32_t', 'aAntennaId'), param('uint32_t', 'bAntennaId')], 
                    is_const=True)
-    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_angle [variable]
-    cls.add_instance_attribute('m_angle', 'ns3::MatrixBasedChannelModel::Double2DVector', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_antennaPair [variable]
+    cls.add_instance_attribute('m_antennaPair', 'std::pair< unsigned int, unsigned int >', is_const=False)
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_channel [variable]
     cls.add_instance_attribute('m_channel', 'ns3::MatrixBasedChannelModel::Complex3DVector', is_const=False)
-    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_delay [variable]
-    cls.add_instance_attribute('m_delay', 'ns3::MatrixBasedChannelModel::DoubleVector', is_const=False)
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_generatedTime [variable]
     cls.add_instance_attribute('m_generatedTime', 'ns3::Time', is_const=False)
     ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelMatrix::m_nodeIds [variable]
     cls.add_instance_attribute('m_nodeIds', 'std::pair< unsigned int, unsigned int >', is_const=False)
     return
 
+def register_Ns3MatrixBasedChannelModelChannelParams_methods(root_module, cls):
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::ChannelParams() [constructor]
+    cls.add_constructor([])
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::ChannelParams(ns3::MatrixBasedChannelModel::ChannelParams const & arg0) [constructor]
+    cls.add_constructor([param('ns3::MatrixBasedChannelModel::ChannelParams const &', 'arg0')])
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_D [variable]
+    cls.add_instance_attribute('m_D', 'ns3::MatrixBasedChannelModel::DoubleVector', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_alpha [variable]
+    cls.add_instance_attribute('m_alpha', 'ns3::MatrixBasedChannelModel::DoubleVector', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_angle [variable]
+    cls.add_instance_attribute('m_angle', 'ns3::MatrixBasedChannelModel::Double2DVector', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_delay [variable]
+    cls.add_instance_attribute('m_delay', 'ns3::MatrixBasedChannelModel::DoubleVector', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_generatedTime [variable]
+    cls.add_instance_attribute('m_generatedTime', 'ns3::Time', is_const=False)
+    ## matrix-based-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::ChannelParams::m_nodeIds [variable]
+    cls.add_instance_attribute('m_nodeIds', 'std::pair< unsigned int, unsigned int >', is_const=False)
+    return
+
 def register_Ns3MatrixPropagationLossModel_methods(root_module, cls):
     ## propagation-loss-model.h (module 'propagation'): static ns3::TypeId ns3::MatrixPropagationLossModel::GetTypeId() [member function]
     cls.add_method('GetTypeId', 
@@ -7716,10 +7801,16 @@
     cls.add_method('ExtractNeighborIndex', 
                    'uint32_t', 
                    [param('uint32_t', 'numberOfBits')])
-    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() [member function]
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetEpoch() const [member function]
+    cls.add_method('GetEpoch', 
+                   'uint32_t', 
+                   [], 
+                   is_const=True)
+    ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetRemainingBits() const [member function]
     cls.add_method('GetRemainingBits', 
                    'uint32_t', 
-                   [])
+                   [], 
+                   is_const=True)
     ## nix-vector.h (module 'network'): uint32_t ns3::NixVector::GetSerializedSize() const [member function]
     cls.add_method('GetSerializedSize', 
                    'uint32_t', 
@@ -7730,6 +7821,10 @@
                    'uint32_t', 
                    [param('uint32_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
+    ## nix-vector.h (module 'network'): void ns3::NixVector::SetEpoch(uint32_t epoch) [member function]
+    cls.add_method('SetEpoch', 
+                   'void', 
+                   [param('uint32_t', 'epoch')])
     return
 
 def register_Ns3Node_methods(root_module, cls):
@@ -8243,10 +8338,11 @@
                    'uint32_t', 
                    [param('uint8_t *', 'buffer'), param('uint32_t', 'maxSize')], 
                    is_const=True)
-    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) [member function]
+    ## packet.h (module 'network'): void ns3::Packet::SetNixVector(ns3::Ptr<ns3::NixVector> nixVector) const [member function]
     cls.add_method('SetNixVector', 
                    'void', 
-                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')])
+                   [param('ns3::Ptr< ns3::NixVector >', 'nixVector')], 
+                   is_const=True)
     ## packet.h (module 'network'): std::string ns3::Packet::ToString() const [member function]
     cls.add_method('ToString', 
                    'std::string', 
@@ -8625,9 +8721,9 @@
                    'ns3::Ptr< ns3::SpectrumModel const >', 
                    [], 
                    is_const=True, is_virtual=True)
-    ## spectrum-analyzer.h (module 'spectrum'): ns3::Ptr<ns3::AntennaModel> ns3::SpectrumAnalyzer::GetRxAntenna() const [member function]
-    cls.add_method('GetRxAntenna', 
-                   'ns3::Ptr< ns3::AntennaModel >', 
+    ## spectrum-analyzer.h (module 'spectrum'): ns3::Ptr<ns3::Object> ns3::SpectrumAnalyzer::GetAntenna() const [member function]
+    cls.add_method('GetAntenna', 
+                   'ns3::Ptr< ns3::Object >', 
                    [], 
                    is_const=True, is_virtual=True)
     ## spectrum-analyzer.h (module 'spectrum'): void ns3::SpectrumAnalyzer::StartRx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
@@ -8670,6 +8766,10 @@
     cls.add_constructor([param('ns3::SpectrumChannel const &', 'arg0')])
     ## spectrum-channel.h (module 'spectrum'): ns3::SpectrumChannel::SpectrumChannel() [constructor]
     cls.add_constructor([])
+    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::AddPhasedArraySpectrumPropagationLossModel(ns3::Ptr<ns3::PhasedArraySpectrumPropagationLossModel> loss) [member function]
+    cls.add_method('AddPhasedArraySpectrumPropagationLossModel', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::PhasedArraySpectrumPropagationLossModel >', 'loss')])
     ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::AddPropagationLossModel(ns3::Ptr<ns3::PropagationLossModel> loss) [member function]
     cls.add_method('AddPropagationLossModel', 
                    'void', 
@@ -8688,6 +8788,10 @@
                    'void', 
                    [], 
                    is_virtual=True)
+    ## spectrum-channel.h (module 'spectrum'): ns3::Ptr<ns3::PhasedArraySpectrumPropagationLossModel> ns3::SpectrumChannel::GetPhasedArraySpectrumPropagationLossModel() [member function]
+    cls.add_method('GetPhasedArraySpectrumPropagationLossModel', 
+                   'ns3::Ptr< ns3::PhasedArraySpectrumPropagationLossModel >', 
+                   [])
     ## spectrum-channel.h (module 'spectrum'): ns3::Ptr<ns3::PropagationLossModel> ns3::SpectrumChannel::GetPropagationLossModel() [member function]
     cls.add_method('GetPropagationLossModel', 
                    'ns3::Ptr< ns3::PropagationLossModel >', 
@@ -8701,6 +8805,11 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
+    ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::RemoveRx(ns3::Ptr<ns3::SpectrumPhy> phy) [member function]
+    cls.add_method('RemoveRx', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::SpectrumPhy >', 'phy')], 
+                   is_pure_virtual=True, is_virtual=True)
     ## spectrum-channel.h (module 'spectrum'): void ns3::SpectrumChannel::SetPropagationDelayModel(ns3::Ptr<ns3::PropagationDelayModel> delay) [member function]
     cls.add_method('SetPropagationDelayModel', 
                    'void', 
@@ -8781,6 +8890,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## three-gpp-channel-model.h (module 'spectrum'): ns3::Ptr<const ns3::MatrixBasedChannelModel::ChannelParams> ns3::ThreeGppChannelModel::GetParams(ns3::Ptr<const ns3::MobilityModel> aMob, ns3::Ptr<const ns3::MobilityModel> bMob) const [member function]
+    cls.add_method('GetParams', 
+                   'ns3::Ptr< ns3::MatrixBasedChannelModel::ChannelParams const >', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'aMob'), param('ns3::Ptr< ns3::MobilityModel const >', 'bMob')], 
+                   is_const=True, is_virtual=True)
     ## three-gpp-channel-model.h (module 'spectrum'): std::string ns3::ThreeGppChannelModel::GetScenario() const [member function]
     cls.add_method('GetScenario', 
                    'std::string', 
@@ -8803,11 +8917,46 @@
     cls.add_method('SetScenario', 
                    'void', 
                    [param('std::string const &', 'scenario')])
+    ## three-gpp-channel-model.h (module 'spectrum'): ns3::MatrixBasedChannelModel::DoubleVector ns3::ThreeGppChannelModel::CalcAttenuationOfBlockage(ns3::Ptr<ns3::ThreeGppChannelModel::ThreeGppChannelParams> const channelParams, ns3::MatrixBasedChannelModel::DoubleVector const & clusterAOA, ns3::MatrixBasedChannelModel::DoubleVector const & clusterZOA) const [member function]
+    cls.add_method('CalcAttenuationOfBlockage', 
+                   'ns3::MatrixBasedChannelModel::DoubleVector', 
+                   [param('ns3::Ptr< ns3::ThreeGppChannelModel::ThreeGppChannelParams > const', 'channelParams'), param('ns3::MatrixBasedChannelModel::DoubleVector const &', 'clusterAOA'), param('ns3::MatrixBasedChannelModel::DoubleVector const &', 'clusterZOA')], 
+                   is_const=True, visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): bool ns3::ThreeGppChannelModel::ChannelMatrixNeedsUpdate(ns3::Ptr<const ns3::ThreeGppChannelModel::ThreeGppChannelParams> channelParams, ns3::Ptr<const ns3::MatrixBasedChannelModel::ChannelMatrix> channelMatrix) [member function]
+    cls.add_method('ChannelMatrixNeedsUpdate', 
+                   'bool', 
+                   [param('ns3::Ptr< ns3::ThreeGppChannelModel::ThreeGppChannelParams const >', 'channelParams'), param('ns3::Ptr< ns3::MatrixBasedChannelModel::ChannelMatrix const >', 'channelMatrix')], 
+                   visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): bool ns3::ThreeGppChannelModel::ChannelParamsNeedsUpdate(ns3::Ptr<const ns3::ThreeGppChannelModel::ThreeGppChannelParams> channelParams, ns3::Ptr<const ns3::ChannelCondition> channelCondition) const [member function]
+    cls.add_method('ChannelParamsNeedsUpdate', 
+                   'bool', 
+                   [param('ns3::Ptr< ns3::ThreeGppChannelModel::ThreeGppChannelParams const >', 'channelParams'), param('ns3::Ptr< ns3::ChannelCondition const >', 'channelCondition')], 
+                   is_const=True, visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): ns3::Ptr<ns3::ThreeGppChannelModel::ThreeGppChannelParams> ns3::ThreeGppChannelModel::GenerateChannelParameters(ns3::Ptr<const ns3::ChannelCondition> const channelCondition, ns3::Ptr<const ns3::ThreeGppChannelModel::ParamsTable> const table3gpp, ns3::Ptr<const ns3::MobilityModel> const aMob, ns3::Ptr<const ns3::MobilityModel> const bMob) const [member function]
+    cls.add_method('GenerateChannelParameters', 
+                   'ns3::Ptr< ns3::ThreeGppChannelModel::ThreeGppChannelParams >', 
+                   [param('ns3::Ptr< ns3::ChannelCondition const > const', 'channelCondition'), param('ns3::Ptr< ns3::ThreeGppChannelModel::ParamsTable const > const', 'table3gpp'), param('ns3::Ptr< ns3::MobilityModel const > const', 'aMob'), param('ns3::Ptr< ns3::MobilityModel const > const', 'bMob')], 
+                   is_const=True, visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): ns3::Ptr<ns3::MatrixBasedChannelModel::ChannelMatrix> ns3::ThreeGppChannelModel::GetNewChannel(ns3::Ptr<const ns3::ThreeGppChannelModel::ThreeGppChannelParams> channelParams, ns3::Ptr<const ns3::ThreeGppChannelModel::ParamsTable> table3gpp, ns3::Ptr<const ns3::MobilityModel> const sMob, ns3::Ptr<const ns3::MobilityModel> const uMob, ns3::Ptr<const ns3::PhasedArrayModel> sAntenna, ns3::Ptr<const ns3::PhasedArrayModel> uAntenna) const [member function]
+    cls.add_method('GetNewChannel', 
+                   'ns3::Ptr< ns3::MatrixBasedChannelModel::ChannelMatrix >', 
+                   [param('ns3::Ptr< ns3::ThreeGppChannelModel::ThreeGppChannelParams const >', 'channelParams'), param('ns3::Ptr< ns3::ThreeGppChannelModel::ParamsTable const >', 'table3gpp'), param('ns3::Ptr< ns3::MobilityModel const > const', 'sMob'), param('ns3::Ptr< ns3::MobilityModel const > const', 'uMob'), param('ns3::Ptr< ns3::PhasedArrayModel const >', 'sAntenna'), param('ns3::Ptr< ns3::PhasedArrayModel const >', 'uAntenna')], 
+                   is_const=True, is_virtual=True, visibility='protected')
     ## three-gpp-channel-model.h (module 'spectrum'): ns3::Ptr<const ns3::ThreeGppChannelModel::ParamsTable> ns3::ThreeGppChannelModel::GetThreeGppTable(ns3::Ptr<const ns3::ChannelCondition> channelCondition, double hBS, double hUT, double distance2D) const [member function]
     cls.add_method('GetThreeGppTable', 
                    'ns3::Ptr< ns3::ThreeGppChannelModel::ParamsTable const >', 
                    [param('ns3::Ptr< ns3::ChannelCondition const >', 'channelCondition'), param('double', 'hBS'), param('double', 'hUT'), param('double', 'distance2D')], 
-                   is_const=True, is_virtual=True, visibility='private')
+                   is_const=True, is_virtual=True, visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): void ns3::ThreeGppChannelModel::Shuffle(double * first, double * last) const [member function]
+    cls.add_method('Shuffle', 
+                   'void', 
+                   [param('double *', 'first'), param('double *', 'last')], 
+                   is_const=True, visibility='protected')
+    ## three-gpp-channel-model.h (module 'spectrum'): static std::pair<double, double> ns3::ThreeGppChannelModel::WrapAngles(double azimuthRad, double inclinationRad) [member function]
+    cls.add_method('WrapAngles', 
+                   'std::pair< double, double >', 
+                   [param('double', 'azimuthRad'), param('double', 'inclinationRad')], 
+                   is_static=True, visibility='protected')
     return
 
 def register_Ns3ThreeGppIndoorMixedOfficeChannelConditionModel_methods(root_module, cls):
@@ -9264,7 +9413,7 @@
                    'void', 
                    [param('ns3::Callback< bool, ns3::Ptr< ns3::NetDevice >, ns3::Ptr< ns3::Packet const >, unsigned short, ns3::Address const &, ns3::Address const &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty >', 'cb')], 
                    is_virtual=True)
-    ## aloha-noack-net-device.h (module 'spectrum'): void ns3::AlohaNoackNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet> > queue) [member function]
+    ## aloha-noack-net-device.h (module 'spectrum'): void ns3::AlohaNoackNetDevice::SetQueue(ns3::Ptr<ns3::Queue<ns3::Packet>> queue) [member function]
     cls.add_method('SetQueue', 
                    'void', 
                    [param('ns3::Ptr< ns3::Queue< ns3::Packet > >', 'queue')], 
@@ -9661,6 +9810,11 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
+    ## multi-model-spectrum-channel.h (module 'spectrum'): void ns3::MultiModelSpectrumChannel::RemoveRx(ns3::Ptr<ns3::SpectrumPhy> phy) [member function]
+    cls.add_method('RemoveRx', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::SpectrumPhy >', 'phy')], 
+                   is_virtual=True)
     ## multi-model-spectrum-channel.h (module 'spectrum'): void ns3::MultiModelSpectrumChannel::StartTx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
     cls.add_method('StartTx', 
                    'void', 
@@ -9756,6 +9910,11 @@
                    'ns3::TypeId', 
                    [], 
                    is_static=True)
+    ## single-model-spectrum-channel.h (module 'spectrum'): void ns3::SingleModelSpectrumChannel::RemoveRx(ns3::Ptr<ns3::SpectrumPhy> phy) [member function]
+    cls.add_method('RemoveRx', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::SpectrumPhy >', 'phy')], 
+                   is_virtual=True)
     ## single-model-spectrum-channel.h (module 'spectrum'): void ns3::SingleModelSpectrumChannel::StartTx(ns3::Ptr<ns3::SpectrumSignalParameters> params) [member function]
     cls.add_method('StartTx', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/CMakeLists.txt ns-3.36/src/spectrum/CMakeLists.txt
--- ns-3.35/src/spectrum/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/spectrum/CMakeLists.txt	2022-04-30 18:23:58.142734800 -0700
@@ -0,0 +1,92 @@
+set(source_files
+    helper/adhoc-aloha-noack-ideal-phy-helper.cc
+    helper/spectrum-analyzer-helper.cc
+    helper/spectrum-helper.cc
+    helper/tv-spectrum-transmitter-helper.cc
+    helper/waveform-generator-helper.cc
+    model/aloha-noack-mac-header.cc
+    model/aloha-noack-net-device.cc
+    model/constant-spectrum-propagation-loss.cc
+    model/friis-spectrum-propagation-loss.cc
+    model/half-duplex-ideal-phy-signal-parameters.cc
+    model/half-duplex-ideal-phy.cc
+    model/matrix-based-channel-model.cc
+    model/microwave-oven-spectrum-value-helper.cc
+    model/multi-model-spectrum-channel.cc
+    model/non-communicating-net-device.cc
+    model/single-model-spectrum-channel.cc
+    model/spectrum-analyzer.cc
+    model/spectrum-channel.cc
+    model/spectrum-converter.cc
+    model/spectrum-error-model.cc
+    model/spectrum-interference.cc
+    model/spectrum-model-300kHz-300GHz-log.cc
+    model/spectrum-model-ism2400MHz-res1MHz.cc
+    model/spectrum-model.cc
+    model/spectrum-phy.cc
+    model/spectrum-propagation-loss-model.cc
+    model/phased-array-spectrum-propagation-loss-model.cc
+    model/spectrum-signal-parameters.cc
+    model/spectrum-value.cc
+    model/three-gpp-channel-model.cc
+    model/three-gpp-spectrum-propagation-loss-model.cc
+    model/trace-fading-loss-model.cc
+    model/tv-spectrum-transmitter.cc
+    model/waveform-generator.cc
+    model/wifi-spectrum-value-helper.cc
+)
+
+set(header_files
+    helper/adhoc-aloha-noack-ideal-phy-helper.h
+    helper/spectrum-analyzer-helper.h
+    helper/spectrum-helper.h
+    helper/tv-spectrum-transmitter-helper.h
+    helper/waveform-generator-helper.h
+    model/aloha-noack-mac-header.h
+    model/aloha-noack-net-device.h
+    model/constant-spectrum-propagation-loss.h
+    model/friis-spectrum-propagation-loss.h
+    model/half-duplex-ideal-phy-signal-parameters.h
+    model/half-duplex-ideal-phy.h
+    model/matrix-based-channel-model.h
+    model/microwave-oven-spectrum-value-helper.h
+    model/multi-model-spectrum-channel.h
+    model/non-communicating-net-device.h
+    model/single-model-spectrum-channel.h
+    model/spectrum-analyzer.h
+    model/spectrum-channel.h
+    model/spectrum-converter.h
+    model/spectrum-error-model.h
+    model/spectrum-interference.h
+    model/spectrum-model-300kHz-300GHz-log.h
+    model/spectrum-model-ism2400MHz-res1MHz.h
+    model/spectrum-model.h
+    model/spectrum-phy.h
+    model/spectrum-propagation-loss-model.h
+    model/phased-array-spectrum-propagation-loss-model.h
+    model/spectrum-signal-parameters.h
+    model/spectrum-value.h
+    model/three-gpp-channel-model.h
+    model/three-gpp-spectrum-propagation-loss-model.h
+    model/trace-fading-loss-model.h
+    model/tv-spectrum-transmitter.h
+    model/waveform-generator.h
+    model/wifi-spectrum-value-helper.h
+    test/spectrum-test.h
+)
+
+build_lib(
+  LIBNAME spectrum
+  SOURCE_FILES ${source_files}
+  HEADER_FILES ${header_files}
+  LIBRARIES_TO_LINK ${libpropagation}
+                    ${libantenna}
+  TEST_SOURCES
+    test/spectrum-ideal-phy-test.cc
+    test/spectrum-interference-test.cc
+    test/spectrum-value-test.cc
+    test/spectrum-waveform-generator-test.cc
+    test/three-gpp-channel-test-suite.cc
+    test/tv-helper-distribution-test.cc
+    test/tv-spectrum-transmitter-test.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/doc/spectrum-channel-phy-interface.seqdiag ns-3.36/src/spectrum/doc/spectrum-channel-phy-interface.seqdiag
--- ns-3.35/src/spectrum/doc/spectrum-channel-phy-interface.seqdiag	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/doc/spectrum-channel-phy-interface.seqdiag	2022-04-30 18:23:58.142734800 -0700
@@ -14,14 +14,14 @@
 
 	BSpectrumPhy <<- SpectrumChannel [label="GetMobility ()"]
 	BSpectrumPhy <<- SpectrumChannel [label="GetRxSpectrumModel ()"]
-	BSpectrumPhy <<- SpectrumChannel [label="GetRxAntenna ()"]
+	BSpectrumPhy <<- SpectrumChannel [label="GetAntenna ()"]
 	SpectrumChannel -> SpectrumChannel [label="evaluate propagation between A and B"]
 	BSpectrumPhy  <<- SpectrumChannel[label="StartRx (SpectrumSignalParameters)"]
 
 	CSpectrumPhy  <<- SpectrumChannel[label="GetMobility ()"]
 	CSpectrumPhy  <<- SpectrumChannel[label="GetRxSpectrumModel ()"]
 	CSpectrumPhy  <<- SpectrumChannel[label="GetRxSpectrumModel ()"]
-	CSpectrumPhy  <<- SpectrumChannel[label="GetRxAntenna ()"]
+	CSpectrumPhy  <<- SpectrumChannel[label="GetAntenna ()"]
 	SpectrumChannel ->> SpectrumChannel [label="evaluate propagation between A and C"]
 	CSpectrumPhy  <<- SpectrumChannel[label="StartRx (SpectrumSignalParameters)"]
 
@@ -32,7 +32,7 @@
 	CSpectrumPhy  <<- SpectrumChannel[label="GetMobility ()"]
 	CSpectrumPhy  <<- SpectrumChannel[label="GetRxSpectrumModel ()"]
 	CSpectrumPhy  <<- SpectrumChannel[label="GetRxSpectrumModel ()"]
-	CSpectrumPhy  <<- SpectrumChannel[label="GetRxAntenna ()"]
+	CSpectrumPhy  <<- SpectrumChannel[label="GetAntenna ()"]
 	SpectrumChannel ->> SpectrumChannel [label="evaluate propagation between B and C"]
 	CSpectrumPhy  <<- SpectrumChannel[label="StartRx (SpectrumSignalParameters)"]
 
